inventory/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/print', 'ReportController@generate')->name('report');

Route::get('/profil', 'ProfilController@index')->name('profil');

Route::get('/transaksi', 'TransaksiController@index')->name('transaksi');

Route::get('/trs_detail', 'TransaksiDetailController@index')->name('trs_detail');





































# Harun 

Route::resource('barang', 'BarangController')->middleware('auth');

Route::resource('kategori', 'KategoriController')->middleware('auth');

Route::get('/print/barang', 'ReportController@generateBarangReport')->name('barang.pdf')->middleware('auth');


Route::get('/erd', function () {
    return view('about/erd');
})->middleware('auth');

Route::get('/group', function () {
    return view('about/group');
})->middleware('auth');

inventory/app/Barang.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Barang extends Model
{
    protected $table = 'barang';

    protected $fillable = ['nama','deskripsi', 'gambar', 'saldo_barang'];
    
    public function get_kategori()
    {
    	return $this->belongsToMany('App\Kategori','kategori_barang','barang_id','kategori_id');
    }
}

inventory/app/Http/Controllers/BarangController.php
<?php

namespace App\Http\Controllers;

use App\Barang;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Response;
use Alert;
use App\Kategori;
use Image;

class BarangController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        $daftar_barang = Barang::all();

        return view('barang.list', ['daftar_barang' => $daftar_barang]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {   

        $daftar_kategori = Kategori::all();
        
        return view('barang.create',['daftar_kategori'=>$daftar_kategori]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validatedData = $request->validate([
            'nama' => 'required|unique:barang|max:100',
            'deskripsi' => 'required|max:6000',
            'gambar' => 'required|image|max:1024',
            'daftar_kategori' => 'required|array'
        ]);

        $file_image = $request->file('gambar');
        $filename = time() . '.' . $file_image->getClientOriginalExtension();
        $file_image->move('images',$filename);

        $barang = Barang::create([
            'nama' => $request['nama'],
            'deskripsi' => $request['deskripsi'],
            'gambar' => $filename
        ]);

        //dd($barang);

        //menyimpan many to many di tabel pivot
        $id_kategori = $request['daftar_kategori'];
        foreach ($id_kategori as $id) {
            $barang->get_kategori()->save(Kategori::find($id));
        }
        
        
        $message = 'Barang dengan nama "'. $barang->nama .'" berhasil disimpan!';

        Alert::success('Success Title', $message)->position('bottom-end');

        return redirect()->route('barang.index')->with('success',$message); 
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Barang  $barang
     * @return \Illuminate\Http\Response
     */
    public function show(Barang $barang)
    {
        $barang = Barang::find($barang->id);

        return view('barang.show', ['barang' => $barang]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Barang  $barang
     * @return \Illuminate\Http\Response
     */
    public function edit(Barang $barang)
    {
        $barang = Barang::find($barang->id);

        $daftar_kategori = Kategori::all();

        $id_barang_terpilih = array();

        foreach ($barang->get_kategori as $key => $kategori) {

            $id_barang_terpilih[] = $kategori->id;

        }

        return view('barang.edit', ['barang' => $barang,
            'daftar_kategori' => $daftar_kategori,
            'id_barang_terpilih' => $id_barang_terpilih
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Barang  $barang
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Barang $barang)
    {
        $validatedData = $request->validate([
            'nama' => 'required|unique:barang|max:100',
            'deskripsi' => 'required|max:6000',
            'gambar' => 'required|image|max:1024',
            'daftar_kategori' => 'required|array'
        ]);

        $file_image = $request->file('gambar');
        $filename = time() . '.' . $file_image->getClientOriginalExtension();
        $file_image->move('images',$filename);

        $barang = Barang::find($barang->id);
        $barang->nama = $request['nama'];
        $barang->deskripsi = $request['deskripsi'];
        $barang->gambar = $filename;

        $barang->save();

        $barang->get_kategori()->detach();

        $id_kategori = $request['daftar_kategori'];
        foreach ($id_kategori as $id) {
            $barang->get_kategori()->save(Kategori::find($id));
        }

        $message = 'Barang dengan nama "'. $barang->nama .'" berhasil diubah!';

        Alert::success('Success Title', $message)->position('bottom-end');;
        
        return redirect()->route('barang.index')->with('success',$message); 
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Barang  $barang
     * @return \Illuminate\Http\Response
     */
    public function destroy(Barang $barang)
    {
        
        $barang=Barang::find($barang->id);

        $barang->get_kategori()->detach();

        Barang::destroy($barang->id);    


        $message = 'Barang dengan nama "'. $barang->nama .'" berhasil dihapus!';
        Alert::success('Success Title', $message)->position('bottom-end');;

        return redirect()->route('barang.index')->with('success',$message); 
    }
    
}

inventory/resources/views/barang/create.blade.php
@extends('adminlte/master')

@push('styles')

  <link rel="stylesheet" href="{{asset('/adminlte/plugins/select2/css/select2.min.css')}}">

@endpush

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Masukkan Data Barang</h3>
      </div>
      <!-- /.card-header -->

		@if ($errors->any())
		    <div class="alert alert-danger">
		        <ul>
		            @foreach ($errors->all() as $error)
		                <li>{{ $error }}</li>
		            @endforeach
		        </ul>
		    </div>
		@endif

      <!-- form start -->
      <form role="form" action="{{route('barang.store')}}" method="POST" enctype="multipart/form-data">
      	@method('POST')
      	@csrf
        
        <div class="card-body">
          <div class="form-group">
            <label for="nama_id" >Nama</label>
            <input type="text" class="form-control" id="nama_id" placeholder="Masukkan nama" name="nama" value="{{old('nama','')}}" >
             @error('nama')
    			     <div class="alert alert-danger">{{ $message }}</div>
			       @enderror	
          </div>        

          <div class="form-group">
            <label for="deskripsi_id" >Deskripsi</label>

            <textarea id="deskripsi_id" class="deskripsi" name="deskripsi">{{old('deskripsi','')}}</textarea>                        
             @error('deskripsi')
               <div class="alert alert-danger">{{ $message }}</div>
             @enderror  
          </div>        

          <div class="custom-file">
            <input type="file" class="custom-file-input" id="gambar_id" placeholder="Pilih file gambar" name="gambar" value="{{old('gambar','')}}">
            <label class="custom-file-label" for="gambar_id">Pilih File Gambar</label>
            @error('gambar')
              <div class="alert alert-danger">{{ $message }}</div>
            @enderror  
          </div> 
          
          <div class="form-group">
            
            <label for="kategori_id" >Kategori</label>            

            <select class="js-example-basic-multiple" name="daftar_kategori[]" multiple="multiple" id="kategori_id" >
              @foreach ($daftar_kategori as $key => $kategori)
                <option value="{{$kategori->id}}">{{$kategori->nama}}</option>
              @endforeach  

            </select>

             @error('daftar_kategori')
               <div class="alert alert-danger">{{ $message }}</div>
             @enderror  
          </div>     

          
        </div>
        <!-- /.card-body -->

        <div class="card-footer">
          <button type="submit" class="btn btn-primary">Simpan Data Barang</button>
        </div>
       </form>
    </div>

@endsection


@push('scripts')
    
  <script src="{{asset('/adminlte/plugins/select2/js/select2.min.js')}}"></script>
  <script src="{{asset('/adminlte/plugins/bs-custom-file-input/bs-custom-file-input.min.js')}}"></script>
  <script src="https://cloud.tinymce.com/stable/tinymce.min.js"></script>

  <script type="text/javascript">
    
    $(document).ready(function() {
      $('.js-example-basic-multiple').select2();
    });

    $(document).ready(function () {
      bsCustomFileInput.init();
    });
  
  </script>

  <script>
      tinymce.init({
          selector:'textarea.deskripsi',
          width: 900,
          height: 300
      });
  </script>  

@endpush

inventory/resources/views/barang/edit.blade.php
@extends('adminlte/master')

@push('styles')

  <link rel="stylesheet" href="{{asset('/adminlte/plugins/select2/css/select2.min.css')}}">

@endpush

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Update Data Barang</h3>
      </div>
      <!-- /.card-header -->

		@if ($errors->any())
		    <div class="alert alert-danger">
		        <ul>
		            @foreach ($errors->all() as $error)
		                <li>{{ $error }}</li>
		            @endforeach
		        </ul>
		    </div>
		@endif

      <!-- form start -->
      <form role="form" action="{{route('barang.update',['barang'=>$barang])}}" method="POST" enctype="multipart/form-data">
      	@method('PUT')
      	@csrf
        <div class="card-body">
          <div class="form-group">
            <label for="nama_id">Nama</label>
            <input type="text" class="form-control" id="nama_id" placeholder="Masukkan Nama" name="nama" value="{{old('nama',$barang->nama)}}">
            @error('isi')
  			       <div class="alert alert-danger">{{ $message }}</div>
		        @enderror
          </div>   

          <div class="form-group">
            <label for="isi_id">Deskripsi</label>
            <textarea id="deskripsi_id" class="deskripsi" name="deskripsi">{{old('deskripsi',$barang->deskripsi)}}</textarea>                        
             @error('deskripsi')
               <div class="alert alert-danger">{{ $message }}</div>
             @enderror
          </div>   

          <div class="form-group">
            <div class="custom-file">
              <input type="file" class="custom-file-input" id="gambar_id" placeholder="Pilih file gambar" name="gambar" value="{{old('gambar',$barang->gambar)}}">
              <label class="custom-file-label" for="gambar_id">Pilih File Gambar</label>
              @error('gambar')
                <div class="alert alert-danger">{{ $message }}</div>
              @enderror  
            </div> 
          </div>

          <div class="form-group">
            
            <label for="kategori_id" >Kategori</label>            

            <select class="js-example-basic-multiple" name="daftar_kategori[]" multiple="multiple" id="kategori_id" >
              
              @foreach ($daftar_kategori as $key => $kategori)
                <option value="{{$kategori->id}}"

                  {{in_array($kategori->id, $id_barang_terpilih)?'selected':''}}    

                  >{{$kategori->nama}}</option>
              @endforeach  

            </select>

             @error('daftar_kategori')
               <div class="alert alert-danger">{{ $message }}</div>
             @enderror  
          </div>     

          
        </div>
        <!-- /.card-body -->

        <div class="card-footer">
          <button type="submit" class="btn btn-primary">Ubah Jawaban</button>
        </div>
      </form>
    </div>

@endsection

@push('scripts')
    
  <script src="{{asset('/adminlte/plugins/select2/js/select2.min.js')}}"></script>
  <script src="https://cloud.tinymce.com/stable/tinymce.min.js"></script>

  <script type="text/javascript">
    
    $(document).ready(function() {
      $('.js-example-basic-multiple').select2();
    });

    $(document).ready(function () {
      bsCustomFileInput.init();
    });
  
  </script>

  <script>
      tinymce.init({
          selector:'textarea.deskripsi',
          width: 900,
          height: 300
      });
  </script>  
  

@endpush

inventory/resources/views/barang/list.blade.php
@extends('adminlte/master')

@push('styles')

  <link rel="stylesheet" href="{{asset('/adminlte/plugins/datatables-bs4/css/dataTables.bootstrap4.css')}}">

@endpush

@section('content')

<div class="card">
      <div class="card-header">
        <h3 class="card-title">Daftar Barang</h3>
      </div>
      <!-- /.card-header -->      

      <div class="card-body">

      	@if (session('success'))
		      <div class="alert alert-success" role="alert"> {{session('success')}} </div>
		    @endif

      	<a type="button" class="btn btn-primary mb-2" href="{{route('barang.create')}}">Tambah barang baru</a>
      	
        <table id="example1" class="table table-bordered table-striped">
          <thead>
          <tr>
            <th>No.</th>
            <th>Nama</th>
            <th>Qty</th>
            <th>Deskripsi</th>
            <th>Gambar</th>
            <th>Action</th>            
          </tr>
          </thead>
          <tbody>          	
          	@foreach ($daftar_barang as $key => $barang)    			
    			<tr>
	          		<td>{{$key+1}}</td>	
	            	<td>{{$barang->nama}}</td>
	            	<td>{{$barang->saldo_barang}}</td>
                <td>{!!$barang->deskripsi!!}</td>
                <td>                  
                  <img src="{{URL::to('/images/')}}/{{$barang->gambar}}" class="img-thumbnail" width="75">
                </td>
	            	<td style="display: flex;">
	            		<a type="button" class="btn btn-info btn-sm" href="{{route('barang.show',['barang'=>$barang])}}">lihat</a>
	            		<a type="button" class="btn btn-warning btn-sm" href="{{route('barang.edit',['barang'=>$barang])}}">ubah</a>
	            		<form role="form" action="{{route('barang.destroy',['barang'=>$barang])}}" method="POST">
	            			@method('DELETE')
      						@csrf
	            			<button type="submit" class="btn btn-danger btn-sm">Hapus</button>
	            		</form>
	            	</td>            
	          </tr>
			@endforeach
			
          </tbody>          
        </table>

        <a type="button" class="btn btn-dark mb-2" href="{{route('barang.pdf')}}">Cetak Data Barang!</a>
        
      </div>
      <!-- /.card-body -->

    </div>

@endsection

@push('scripts')
  
  <script src="{{asset('/adminlte/plugins/datatables/jquery.dataTables.js')}}"></script>
  <script src="{{asset('/adminlte/plugins/datatables-bs4/js/dataTables.bootstrap4.js')}}"></script>
  
  <script>
    $(function () {
      $("#example1").DataTable();
    });
  </script>

@endpush

inventory/resources/views/barang/show.blade.php
@extends('adminlte/master')

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Data Barang</h3>
      </div>
      <!-- /.card-header -->
      <!-- form start -->
        
        <div class="card ml-3 mr-3 mt-3 mb-3">
          <div class="card-body" >
            <h5 class="card-title">Nama : {{$barang->nama}}</h5>
            <p class="card-text">Deskripsi : {!! $barang->deskripsi !!}</p>
            <p class="card-text">
              Kategori : 
              <ul>
              @foreach ($barang->get_kategori as $key => $kategori)
                <li value="{{$kategori->id}}">{{$kategori->nama}}</li>
              @endforeach  
              </ul>  
            </p>
            <p class="card-image">
              <img src="{{URL::to('/images/')}}/{{$barang->gambar}}" class="img-thumbnail" width="300">
            </p>
            <a class="btn btn-primary" href="{{route('barang.edit',['barang'=>$barang])}}">Ubah Data Barang</a>
          </div>
        </div>

      
    </div>

@endsection